package top.ninwoo.utils;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.util.Assert;
import top.ninwoo.common.entity.DockerContainer;
import top.ninwoo.utils.config.CNFUtilsAutoConfiguration;
import top.ninwoo.utils.util.DockerUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author joliu
 * @Description
 * @Date　Create in 下午5:54 2019/10/25
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = CNFUtilsAutoConfiguration.class)
public class DockerUtilsTest {
    private static String cid = null;
    @Autowired
    DockerUtils dockerUtils;

    @Before
    public void prepare() {
        DockerContainer container = new DockerContainer();
        container.setName("Router_4");
        container.setImage("joliu/networktest");
        container.setCommand("sh");
        cid = dockerUtils.runDocker(container).getId();
    }

    @Test
    public void testGetDockerById() {
        DockerContainer dockerById = dockerUtils.getDockerById(cid);
        Assert.isTrue(dockerById != null);
    }


    @Test
    public void testExecInDocker() {
        final String s =
                dockerUtils.execInDocker("Router_4", new String[]{"ifconfig"});
        Assert.isTrue(!("".equals(s)));
    }

    @After
    public void close() {
        boolean result = dockerUtils.deleteDockerById(cid);
        Assert.isTrue(result);
    }
}
